﻿using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Threading;

using OpenQA.Selenium;
using OpenQA.Selenium.Chrome;
using OpenQA.Selenium.Support.UI;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            ChromeDriverService driverService = ChromeDriverService.CreateDefaultService();

            driverService.HideCommandPromptWindow = true;

            ChromeOptions options = new ChromeOptions();

            options.AddArgument("--start-maximized"); 

            ChromeDriver driver = new ChromeDriver(driverService, options);

            INavigation navigation = driver.Navigate();

            navigation.GoToUrl("https://www.daum.net/");

            WebDriverWait wait = new WebDriverWait(driver, TimeSpan.FromSeconds(10));

            wait.Until(d => (d as IJavaScriptExecutor).ExecuteScript("return document.readyState").Equals("complete"));

            Thread.Sleep(1000);

            IWebElement element = driver.FindElement(By.XPath("//*[@id=\"daumFoot\"]/div/a[1]/img"));

            driver.ExecuteScript("arguments[0].scrollIntoView(true);", element);

            object offsetYObject = driver.ExecuteScript("return window.pageYOffset;");

            int offsetY = (int)float.Parse(offsetYObject.ToString());

            ITakesScreenshot takesScreenshot = driver as ITakesScreenshot;

            Screenshot screenshot = takesScreenshot.GetScreenshot();

            Rectangle elementRectangle = new Rectangle
            (
                element.Location.X,
                element.Location.Y - offsetY,
                element.Size.Width,
                element.Size.Height
            );

            Bitmap screenshotBitmap = new Bitmap(new MemoryStream(screenshot.AsByteArray));

            screenshotBitmap = screenshotBitmap.Clone(elementRectangle, screenshotBitmap.PixelFormat);

            screenshotBitmap.Save("d:\\target.png", ImageFormat.Png);

            screenshotBitmap.Dispose();

            Console.WriteLine("크롬 브라우저를 종료하려면 아무 키나 눌러주시기 바랍니다.");

            Console.ReadKey(false);

            driver.Quit();
        }

        #endregion
    }
}